//+------------------------------------------------------------------+
//|                                           Sigma_Andrea_New_1.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#property copyright ""
#property link      ""
#property version   "1.00"
//#property strict
// ---------- Indicator Settings
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color2 Green
#property indicator_color1 Orange

#property indicator_width1 3
#property indicator_width2 2


#property indicator_level1     0

// ---- indicator parameters

extern int price  = PRICE_CLOSE;
extern int period = 20;
extern int MAperiodo = 20;


//--- indicator buffers
double         Sigma[];
double         Average[];
double         ScartoMedio[];
double         prices[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   
   IndicatorBuffers(3);
      
   SetIndexStyle (0,DRAW_LINE);
   SetIndexBuffer(0,Average);
   SetIndexLabel (0,"Media"); 
   
   SetIndexStyle (1,DRAW_LINE);
   SetIndexBuffer(1,Sigma);
   SetIndexLabel (1,"Sigma");
   
   
   
   SetIndexDrawBegin(0,period+1);
   SetIndexDrawBegin(1,period+1);
   
   IndicatorShortName("Sigma New");
   
   //-----initiation done
   //return(INIT_SUCCEEDED);
   return(0);
  } 
   
   
  



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   int limit,i;
   
   int counted_bars=IndicatorCounted();// --- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  
   // -------- Momentum Buffer
  int n=1;
  for (  i=0; i<limit; i++)
      {  
     
      Sigma[i] = iCalc(Average,period,0,i+1);
        
      Average[i]=(Average[i+1]*n+Sigma[i]) /(n+1)  ;
      
       n++;
    }    
             

   return(0);
  }
//+------------------------------------------------------------------+


double iCalc(double &array[], double cPeriod,int cMode, int i)
{  
   double sigma      =0;
      
       if(cPeriod>1) { sigma=MathAbs(Close[i]-iMA(Symbol(),0,cPeriod,0,MODE_SMA,PRICE_MEDIAN,i));
                                                  }
       else          { sigma=MathAbs(Close[1]-((High[1]+Low[1])/2));}
            
                
   return(sigma);   
 
}

